// [[[$article >= 11]]]
/* Copyright (C) 2005  Thomas Petazzoni

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.
*/

#ifndef __SOS_SOCKET__
#define __SOS_SOCKET__

#include <sos/types.h>
#include <sos/errno.h>

/* Socket domains */
#define PF_INET    0x42

/* Socket types */
#define SOCK_DGRAM 0x42

struct sockaddr_in {
  int        family;
  int        port;
  sos_ui32_t addr;
};

sos_ret_t socket_create (int domain, int type, int protocol, int *fd);
sos_ret_t socket_close (int fd);
sos_ret_t socket_sendto (int fd, sos_uaddr_t buf, sos_size_t len,
			 const struct sockaddr_in *to, sos_size_t tolen);

#endif /* __SOS_SOCKET__ */

// [[[]]]
