// [[[$article >= 6 && $master]]]

#include <drivers/bochs.h>
#include <hwcore/cpu_context.h>

struct sos_cpu_state *ctxt_main;
struct sos_cpu_state *ctxt_gen123;

static void init_gen123(int);

static void gen123 (int arg)
{
  sos_bochs_printf("In gen123(%d): gen 1\n", arg);
  sos_cpu_context_switch(& ctxt_gen123, ctxt_main);

  sos_bochs_printf("In gen123(%d): gen 2\n", arg);
  sos_cpu_context_switch(& ctxt_gen123, ctxt_main);

  sos_bochs_printf("In gen123(%d): gen 3\n", arg);
  sos_cpu_context_switch(& ctxt_gen123, ctxt_main);

  // exit_gen123(7654);
  sos_bochs_printf("In gen123(%d): returning\n", arg);
  return;
}

static void exit_gen123(int arg)
{
  sos_bochs_printf("Exit(%d) gen123 => rewind it\n", arg);
  sos_cpu_context_exit_to(ctxt_main,
			  (sos_cpu_kstate_function_arg1_t*) init_gen123,
			  424242);
}

char gen123_stack[1024];  
static void init_gen123(int arg)
{
  sos_bochs_printf("Init(%d) stack for gen123\n", arg);
  sos_cpu_kstate_init(&ctxt_gen123,
		      (sos_cpu_kstate_function_arg1_t*) gen123, 42,
		      (sos_vaddr_t) gen123_stack, sizeof(gen123_stack),
		      (sos_cpu_kstate_function_arg1_t*) exit_gen123, 4242);
}

void test_art6 ()
{
  int i;
  sos_bochs_printf("init gen123\n");
  init_gen123(1111);

  for (i = 0 ; i < 20 ; i++)
    {
      sos_bochs_printf("Going to call gen123 (iteration %d)...\n", i);
      sos_cpu_context_switch(& ctxt_main, ctxt_gen123);
      sos_bochs_printf("Back in main\n");
    }

  sos_bochs_printf("The end\n");
}

// [[[]]]
