# [[[0]]]

# Regenerate a tree from a source arbo to a destination arbo, applying
# extract.pl with the "$article = the_version" option.

if [ $# -lt 3 ] ; then
  echo "Usage: $0 arbo-model version-article arbo-dest [MASTER]"
  exit 1
fi

modelroot="$1"
shift

article_version="$1"
shift

destroot="$1"
shift

genmaster=""
[ x"$1" == xMASTER ] && genmaster='$master=1'

if [ ! -d "$modelroot" ] ; then
  echo "Pas de rpertoire $modelroot"
  exit 1
fi

if [ -d "$destroot" ] ; then
  echo "Rperoire destination existe dj"
  exit 1
fi

(cd "$modelroot" && find . -type d) | while read d ; do
    case "x$d" in
	x*/.svn) continue;;
	x*/.svn/*) continue;;
    esac
    # echo "Adding dir $d"
    mkdir -p "$destroot/$d"
done

(cd "$modelroot" && find . -type f) | while read f ; do
    case "x$f" in
	x*/.svn/*) continue;;
	x*/.mkvars) continue;;
	x*/.cvsignore) continue;;
	x*/cc) continue;;
	x*/hd*.img) continue;;
    esac
    # echo "Parsing $modelroot/$f"
    if ! perl ./extract.pl '-' '$article='$article_version $genmaster \
	          < "$modelroot/$f" > "$destroot/$f" ; then
      echo Erreur sur le fichier $f.
      exit 1
    fi
    # On vire les fichiers generes qui sont vides
    [ x`wc -c < "$destroot/$f" | xargs echo` = x0 ] && rm -f "$destroot/$f"
done

true
# [[[]]]
